/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
export * as accessControlRuleSet from './access-control-rule-set';
export * as alert from './alert';
export * as artifactAllowlist from './artifact-allowlist';
export * as automaticClusterUpdateWorkspaceSetting from './automatic-cluster-update-workspace-setting';
export * as awsS3Mount from './aws-s3-mount';
export * as azureAdlsGen1Mount from './azure-adls-gen1-mount';
export * as azureAdlsGen2Mount from './azure-adls-gen2-mount';
export * as azureBlobMount from './azure-blob-mount';
export * as budget from './budget';
export * as catalog from './catalog';
export * as catalogWorkspaceBinding from './catalog-workspace-binding';
export * as cluster from './cluster';
export * as clusterPolicy from './cluster-policy';
export * as complianceSecurityProfileWorkspaceSetting from './compliance-security-profile-workspace-setting';
export * as connection from './connection';
export * as customAppIntegration from './custom-app-integration';
export * as dashboard from './dashboard';
export * as dbfsFile from './dbfs-file';
export * as defaultNamespaceSetting from './default-namespace-setting';
export * as directory from './directory';
export * as enhancedSecurityMonitoringWorkspaceSetting from './enhanced-security-monitoring-workspace-setting';
export * as entitlements from './entitlements';
export * as externalLocation from './external-location';
export * as file from './file';
export * as gitCredential from './git-credential';
export * as globalInitScript from './global-init-script';
export * as grant from './grant';
export * as grants from './grants';
export * as group from './group';
export * as groupInstanceProfile from './group-instance-profile';
export * as groupMember from './group-member';
export * as groupRole from './group-role';
export * as instancePool from './instance-pool';
export * as instanceProfile from './instance-profile';
export * as ipAccessList from './ip-access-list';
export * as job from './job';
export * as lakehouseMonitor from './lakehouse-monitor';
export * as library from './library';
export * as metastore from './metastore';
export * as metastoreAssignment from './metastore-assignment';
export * as metastoreDataAccess from './metastore-data-access';
export * as mlflowExperiment from './mlflow-experiment';
export * as mlflowModel from './mlflow-model';
export * as mlflowWebhook from './mlflow-webhook';
export * as modelServing from './model-serving';
export * as mount from './mount';
export * as mwsCredentials from './mws-credentials';
export * as mwsCustomerManagedKeys from './mws-customer-managed-keys';
export * as mwsLogDelivery from './mws-log-delivery';
export * as mwsNccBinding from './mws-ncc-binding';
export * as mwsNccPrivateEndpointRule from './mws-ncc-private-endpoint-rule';
export * as mwsNetworkConnectivityConfig from './mws-network-connectivity-config';
export * as mwsNetworks from './mws-networks';
export * as mwsPermissionAssignment from './mws-permission-assignment';
export * as mwsPrivateAccessSettings from './mws-private-access-settings';
export * as mwsStorageConfigurations from './mws-storage-configurations';
export * as mwsVpcEndpoint from './mws-vpc-endpoint';
export * as mwsWorkspaces from './mws-workspaces';
export * as notebook from './notebook';
export * as notificationDestination from './notification-destination';
export * as oboToken from './obo-token';
export * as onlineTable from './online-table';
export * as permissionAssignment from './permission-assignment';
export * as permissions from './permissions';
export * as pipeline from './pipeline';
export * as providerResource from './provider-resource';
export * as qualityMonitor from './quality-monitor';
export * as query from './query';
export * as recipient from './recipient';
export * as registeredModel from './registered-model';
export * as repo from './repo';
export * as restrictWorkspaceAdminsSetting from './restrict-workspace-admins-setting';
export * as schema from './schema';
export * as secret from './secret';
export * as secretAcl from './secret-acl';
export * as secretScope from './secret-scope';
export * as servicePrincipal from './service-principal';
export * as servicePrincipalRole from './service-principal-role';
export * as servicePrincipalSecret from './service-principal-secret';
export * as share from './share';
export * as sharePluginframework from './share-pluginframework';
export * as sqlAlert from './sql-alert';
export * as sqlDashboard from './sql-dashboard';
export * as sqlEndpoint from './sql-endpoint';
export * as sqlGlobalConfig from './sql-global-config';
export * as sqlPermissions from './sql-permissions';
export * as sqlQuery from './sql-query';
export * as sqlTable from './sql-table';
export * as sqlVisualization from './sql-visualization';
export * as sqlWidget from './sql-widget';
export * as storageCredential from './storage-credential';
export * as systemSchema from './system-schema';
export * as table from './table';
export * as token from './token';
export * as user from './user';
export * as userInstanceProfile from './user-instance-profile';
export * as userRole from './user-role';
export * as vectorSearchEndpoint from './vector-search-endpoint';
export * as vectorSearchIndex from './vector-search-index';
export * as volume from './volume';
export * as workspaceBinding from './workspace-binding';
export * as workspaceConf from './workspace-conf';
export * as workspaceFile from './workspace-file';
export * as dataDatabricksAwsAssumeRolePolicy from './data-databricks-aws-assume-role-policy';
export * as dataDatabricksAwsBucketPolicy from './data-databricks-aws-bucket-policy';
export * as dataDatabricksAwsCrossaccountPolicy from './data-databricks-aws-crossaccount-policy';
export * as dataDatabricksAwsUnityCatalogAssumeRolePolicy from './data-databricks-aws-unity-catalog-assume-role-policy';
export * as dataDatabricksAwsUnityCatalogPolicy from './data-databricks-aws-unity-catalog-policy';
export * as dataDatabricksCatalog from './data-databricks-catalog';
export * as dataDatabricksCatalogs from './data-databricks-catalogs';
export * as dataDatabricksCluster from './data-databricks-cluster';
export * as dataDatabricksClusterPluginframework from './data-databricks-cluster-pluginframework';
export * as dataDatabricksClusterPolicy from './data-databricks-cluster-policy';
export * as dataDatabricksClusters from './data-databricks-clusters';
export * as dataDatabricksCurrentConfig from './data-databricks-current-config';
export * as dataDatabricksCurrentMetastore from './data-databricks-current-metastore';
export * as dataDatabricksCurrentUser from './data-databricks-current-user';
export * as dataDatabricksDbfsFile from './data-databricks-dbfs-file';
export * as dataDatabricksDbfsFilePaths from './data-databricks-dbfs-file-paths';
export * as dataDatabricksDirectory from './data-databricks-directory';
export * as dataDatabricksExternalLocation from './data-databricks-external-location';
export * as dataDatabricksExternalLocations from './data-databricks-external-locations';
export * as dataDatabricksFunctions from './data-databricks-functions';
export * as dataDatabricksGroup from './data-databricks-group';
export * as dataDatabricksInstancePool from './data-databricks-instance-pool';
export * as dataDatabricksInstanceProfiles from './data-databricks-instance-profiles';
export * as dataDatabricksJob from './data-databricks-job';
export * as dataDatabricksJobs from './data-databricks-jobs';
export * as dataDatabricksMetastore from './data-databricks-metastore';
export * as dataDatabricksMetastores from './data-databricks-metastores';
export * as dataDatabricksMlflowExperiment from './data-databricks-mlflow-experiment';
export * as dataDatabricksMlflowModel from './data-databricks-mlflow-model';
export * as dataDatabricksMlflowModels from './data-databricks-mlflow-models';
export * as dataDatabricksMwsCredentials from './data-databricks-mws-credentials';
export * as dataDatabricksMwsNetworkConnectivityConfig from './data-databricks-mws-network-connectivity-config';
export * as dataDatabricksMwsNetworkConnectivityConfigs from './data-databricks-mws-network-connectivity-configs';
export * as dataDatabricksMwsWorkspaces from './data-databricks-mws-workspaces';
export * as dataDatabricksNodeType from './data-databricks-node-type';
export * as dataDatabricksNotebook from './data-databricks-notebook';
export * as dataDatabricksNotebookPaths from './data-databricks-notebook-paths';
export * as dataDatabricksNotificationDestinations from './data-databricks-notification-destinations';
export * as dataDatabricksPipelines from './data-databricks-pipelines';
export * as dataDatabricksRegisteredModel from './data-databricks-registered-model';
export * as dataDatabricksRegisteredModelVersions from './data-databricks-registered-model-versions';
export * as dataDatabricksSchema from './data-databricks-schema';
export * as dataDatabricksSchemas from './data-databricks-schemas';
export * as dataDatabricksServicePrincipal from './data-databricks-service-principal';
export * as dataDatabricksServicePrincipals from './data-databricks-service-principals';
export * as dataDatabricksServingEndpoints from './data-databricks-serving-endpoints';
export * as dataDatabricksShare from './data-databricks-share';
export * as dataDatabricksSharePluginframework from './data-databricks-share-pluginframework';
export * as dataDatabricksShares from './data-databricks-shares';
export * as dataDatabricksSharesPluginframework from './data-databricks-shares-pluginframework';
export * as dataDatabricksSparkVersion from './data-databricks-spark-version';
export * as dataDatabricksSqlWarehouse from './data-databricks-sql-warehouse';
export * as dataDatabricksSqlWarehouses from './data-databricks-sql-warehouses';
export * as dataDatabricksStorageCredential from './data-databricks-storage-credential';
export * as dataDatabricksStorageCredentials from './data-databricks-storage-credentials';
export * as dataDatabricksTable from './data-databricks-table';
export * as dataDatabricksTables from './data-databricks-tables';
export * as dataDatabricksUser from './data-databricks-user';
export * as dataDatabricksViews from './data-databricks-views';
export * as dataDatabricksVolume from './data-databricks-volume';
export * as dataDatabricksVolumes from './data-databricks-volumes';
export * as dataDatabricksZones from './data-databricks-zones';
export * as provider from './provider';
